from gpiozero import Button, LED, TonalBuzzer
from gpiozero.tones import Tone

from openpyxl import load_workbook

import bme280
import datetime, time

bp_acq = Button(4)
bp_fin = Button(20)
led_verte = LED(21)
buz = TonalBuzzer(16)

index = 0
t_acq = 6

    
def acquisition():
    global index
    
    print(" Le bouton poussoir acquisition a été pressé: ")
    print("La durée de l'acquisition est d'environ: ", t_acq, "s")
    
    temperature,pression,humidite = bme280.readBME280All()
    print("Temp : ", temperature, "A°C \t P : ", pression, "hPa \t HR : ", humidite, "%")

#********* module de simulation ******************************
# valeurs de t°, pression pour simuler les données du capteur
#     delta_t = [0.0, 0.1, -0.4, 0.3]
#     delta_p = [0.0, 0.4, 1.2, -0.2]
#     temperature = 22.5 + delta_t[index]
#     pression = 998.6 + delta_p[index]
#     humidite = 60
#**************************************************************
    avertir()
    
    index = index + 1                                # nbre de mesure effectuée
    sauvegarder(temperature,pression,humidite,index)
                            

def avertir():
# avertisseur lumineux
    led_verte.on()
    time.sleep(3)
    led_verte.off()


def son_finacq(numero):
# avertisseur sonore
#     note = [60, 63, 65, 68, 70]
#     
#     for n in range(len(note[n])):
#         buz.play(Tone(midi=note[n]))      # médianne
#         time.sleep(1)
#         buz.stop()
#         time.sleep(3)
# *************   old Mac Donald   *****************************
    couplet_1 =["G4", "G4", "G4", "D4", "E4", "E4", "D4"]
    couplet_2 =["B4", "B4", "A4", "A4", "G4"]
    couplet_3 =["D4", "G4", "G4", "G4", "D4", "E4", "E4", "D4"]

    musique = [couplet_1, couplet_2, couplet_3, couplet_2]
    for partition in musique:
        for note in partition:
           buz.play(note)
           time.sleep(0.4)
           buz.stop()
           time.sleep(0.1)
        time.sleep(0.2)

    print("L'acquisition numéro {0} est terminée".format(numero))   


def sauvegarder(t,p,h,i):   
# mise en forme de la date et de l'horaire
    dat = datetime.datetime.now()
    form_date = dat.strftime("%a %d %B %Y")  # Mon 01 feb 2021
    horaire = time.strftime('%Hh %Mmn %Ss')  # 15H 25mn 36s
    
# la mise en forme des paramètres n'est pas obligatoire
# cette partie est un exemple qui permet d'ajouter du texte à une valeur
# Pour cela, il faut transformer la valeur de type integer en string
# puis ajouter les 2 chaînes de caractères 
    form_t = t      #str(t) + str(" °C")     # 22.5 °C
    form_p = p      #str(p) + str(" hPa")    # 1000.0 hPa
    form_h = h/100  #str(h) + str("%")       # 50%
    form_i = str("n° acq") + str(i)  # n° acq 1
    
# adresse du fichier à renseigner    
    wb = load_workbook('/home/pi/Tp_connect/bme280.xlsx')
    fiche = wb['data']
    
# ajout de la date, horaire et n°acq aux données du capteur        
    ligne = (form_i, form_date, horaire, form_t, form_p, form_h)
    fiche.append(ligne)
    time.sleep(1)
    
# écriture et sauvegarde des données dans fichier   
    wb.save('/home/pi/Tp_connect/bme280.xlsx')
    time.sleep(t_acq)
    
    son_finacq(i)



def fin():
    print("Fin du programme d'acquisition. ")
    print("Pour sortir définitivement du programme Taper CTRL F2 ")
    quit()


bp_acq.when_pressed = acquisition
    
bp_fin.when_pressed = fin
